package com.hitoli.fetchPic;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

import org.apache.commons.lang3.StringUtils;


public class Main {

    public static Set<String> sites = new HashSet<String>(); //所有网站根（防止访问地址越界）
    public static Set<String> transboundarySites = new HashSet<String>(); //可越界的网站根
    public static Set<String> pageSet = new HashSet<String>(); //所有已爬过的地址
    public static Set<PictInfo> readTimeOutImgs = new HashSet<PictInfo>(); //所有读取超时的图片
    public static Set<String> imgDownloaded = new HashSet<String>(); //已经下载的图片地址
    public static Set<String> imgDownloadedDirName = new HashSet<String>();//已经下载的图片目录名称
    public static String home = null;
    public static String downLoadDir = null; //下载目录
    public static String siteData = null; //网站可以扫描的域名地址记录文件（防止越界）
    public static String downLoadedImgData = null; //已经下载的图片地址记录文件
    public static String downloadedImgDirNameData = null; //已经下载的图片目录名称记录文件
    public static String allowDifferentCharacters = "0";//比对下载图片的title和已经下载的图片目录名称记录允许相差的字符数（用于检查图片存放路径的目录是否已经存在）
    public static String readTimeOutImgData = null; //所有读取超时的图片地址记录文件
    public static String allUrlData = null; //所有已爬过的地址记录文件
    public static String currentUrlData = null; //当前正在处理的地址记录文件
    public static String lazyUrlData = null; //延迟处理的地址记录文件
    public static String commandFile = null;//命令文件（每次循环pageLinks检查一次）
    public static long imgMinSize = 1; //下载图片最小单位（KB）
    public static List<String> nextPageNames = Arrays.stream(
                new String[]{"下一页", "下一篇", "下一章", "后", "NEXT", ">", ">>", ">>>"}
            ).collect(Collectors.toList()); //下一页按钮中的text
    public static List<String> pageTitlefilters = Arrays.stream(
            new String[]{"(\\第\\d+\\页)"}
    ).collect(Collectors.toList()); //title中需要过滤的关键字，过滤全部关键字
    public static List<String> imgNamefilters = Arrays.stream(
            new String[]{"LOGO", "FAVICON"}
    ).collect(Collectors.toList()); //下载图片中需要丢弃的图片名称
    public static List<String> imgSrcRepletTags  = Arrays.stream(
            new String[]{"original"}
    ).collect(Collectors.toList()); //下载图片的链接非src标签,如果存在此list中的标签名，则获取对应标签的值为下载链接
    public static String refererUrl = "self"; //下载图片时需要模拟的来源url（如有的情况下）,默认为self（发现图片的html地址）
    public static String fixedUrlPrefix = ""; //只扫描固定前缀的url
    public static int browserTimeout = 5000;//请求超时时间,默认5秒
    public static int jsTimeout = 1000;//请求超时时间,默认1秒
    public static int waitForBackgroundJavaScript = 1;//等待异步JS执行时间,默认1秒
    public static boolean jsEnabled = true;//是否启用js
    public static boolean thread = false; //是否多线程下载
    public static int threadSize = 5; //一次开启的线程数
    public static int threadSleep = 1; //开满线程数后等待多少秒
    public static boolean stop = false; //是否退出
    public static boolean autoSaveMemoryData = true; //自动保存内存数据到文件
    public static int autoSaveMemoryDataInterval = 3; //保存间隔（分钟）
    public static Long lastAutoSaveMemoryDataTime = null; //最后一次保存时间

    public static void main(String[] args) {

        HttpUtils.getInstance().initWebClient(browserTimeout, jsTimeout, jsEnabled, waitForBackgroundJavaScript);
        List<String> pageLinks = new ArrayList<String>();
        List<String> lazyPageLinks = new ArrayList<>();
        List<PictInfo> pictInfos = new ArrayList<PictInfo>();
        init(args, pageLinks, lazyPageLinks, pictInfos);

        int networkExceptionRetryCount = 5;//连续访问url失败次数
        Set<String> failUrls = new HashSet<String>();
        while(pageLinks.size() > 0){
            int connectExceptionRetryCount = 5;//重复访问同一url失败次数

            String url = pageLinks.get(0);
            if (StringUtils.isEmpty(url)) {
                pageLinks.remove(0);
                continue;
            }
            if (StringUtils.isNotEmpty(fixedUrlPrefix)) {
                if (!url.startsWith(fixedUrlPrefix)) {
                    pageLinks.remove(0);
                    continue;
                }
            }

            //分析页面所有连接
            boolean result = FindLink.addPageLink(url, pageLinks, lazyPageLinks, connectExceptionRetryCount);
            //分析页面所有图片
            if (result) {
                networkExceptionRetryCount = 5;//访问成功，恢复次数
                String nextPageUrl = "";
                if (pageLinks.size() >= 2) {
                    nextPageUrl = pageLinks.get(1);
                }
                result = FindLink.addPictLink(url, pictInfos, nextPageUrl, connectExceptionRetryCount);
                if (!result) {
                    failUrls.add(url);
                    networkExceptionRetryCount--;
                } else {
                    networkExceptionRetryCount = 5;//访问成功，恢复次数
                }
            } else {
                failUrls.add(url);
                networkExceptionRetryCount--;
            }
            if (networkExceptionRetryCount <= 0) {
                Utils.error("网络可能出现问题，连续访问5次不同url失败");
                pageLinks.remove(0);
                pageLinks.addAll(0, failUrls);
                pageSet.removeAll(failUrls);
                writeMemoryDataToFile(pageLinks, lazyPageLinks);
                writeDefaultCommand();
                System.exit(0);
            }
            if (pictInfos.size() > 0) {
                Utils.info("url[" + url + "]中找到" + pictInfos.size() + "个可用图片连接");
                DownLoad.downloadPict(pictInfos);
            } else {
                Utils.info("url[" + url + "]中找到0可用图片连接");
            }
            pageLinks.remove(0);

            //图片链接扫描完后取非图片链接继续扫描
            getLazyUrl(pageLinks, lazyPageLinks);

            //检查命令文件，如果stop等于true或者pagelinks为空则停止程序
            checkAndExecutCommand(pageLinks, lazyPageLinks);

            //检查是否自动保存内存数据
            checkAutoSaveMemoryData(pageLinks, lazyPageLinks);
        }

    }

    private static void init(String[] prams, List<String> pageLinks, List<String> lazyPageLinks, List<PictInfo> pictInfos) {

        if (thread) {
            sites = Collections.synchronizedSet(new HashSet<String>());
            pageSet = Collections.synchronizedSet(new HashSet<String>());
            imgDownloaded = Collections.synchronizedSet(new HashSet<String>());
            readTimeOutImgs = Collections.synchronizedSet(new HashSet<PictInfo>());
            pageLinks = Collections.synchronizedList(new ArrayList<String>());
            lazyPageLinks = Collections.synchronizedList(new ArrayList<String>());
            pictInfos = Collections.synchronizedList(new ArrayList<PictInfo>());
        }

        //图片保存路径
        home = "";
        if (null != prams && prams.length > 0) {
            home = prams[0];
        }
        System.out.println("HOME路径为：" + home);
        if (!Utils.checkFilePathExists(home)) {
            System.out.println("HOME路径不存在,请手动创建");
            System.exit(1);
        }

        downLoadDir = home.endsWith(File.separator) ? (home + "pict") : (home + File.separator + "pict");
        //创建文件下载目录
        Utils.createDir(downLoadDir);
        siteData = downLoadDir + File.separator + "siteData";
        downLoadedImgData = downLoadDir + File.separator + "downLoadedImgData";
        downloadedImgDirNameData = downLoadDir + File.separator + "downloadedImgDirNameData";
        readTimeOutImgData = downLoadDir + File.separator + "readTimeOutImgData";
        allUrlData = downLoadDir + File.separator + "allUrlData";
        currentUrlData = downLoadDir + File.separator + "currentUrlData";
        lazyUrlData = downLoadDir + File.separator + "lazyUrlData";
        commandFile = downLoadDir + File.separator + "command";
        //创建网站域名地址记录文件(不存在才创建)
        Utils.createFile(siteData);
        //创建下载记录文件(不存在才创建)
        Utils.createFile(downLoadedImgData);
        //创建已经下载的图片目录名称文件(不存在才创建)
        Utils.createFile(downloadedImgDirNameData);
        //创建读取超时记录文件(不存在才创建)
        Utils.createFile(readTimeOutImgData);
        //创建所有已爬过的地址记录文件(不存在才创建)
        Utils.createFile(allUrlData);
        //创建当前需要处理的地址记录文件(不存在才创建)
        Utils.createFile(currentUrlData);
        //创建延迟处理的地址记录文件(不存在才创建)
        Utils.createFile(lazyUrlData);
        //创建命令文件(不存在才创建)
        Utils.createFile(commandFile);
        //写入初始命令
        writeDefaultCommand();
        //读取网站域名地址记录到内存中
        Utils.readFileDataToCollection(siteData, sites);
        //读取已经下载的文件记录到内存中
        Utils.readFileDataToCollection(downLoadedImgData, imgDownloaded);
        //读取已经下载的图片目录名称到内存中
        Utils.readFileDataToCollection(downloadedImgDirNameData, imgDownloadedDirName);
        //读取超时文件记录到内存中
        Utils.readFilePictInfoDataToCollection(readTimeOutImgData, readTimeOutImgs);
        //读取所有已爬过的地址记录到内存中
        Utils.readFileDataToCollection(allUrlData, pageSet);

        //读取当前需要处理的连接地址记录到内存中
        Utils.readFileDataToCollection(currentUrlData, pageLinks);
        //读取延迟处理的连接地址记录到内存中
        Utils.readFileDataToCollection(lazyUrlData, lazyPageLinks);
        //图片链接扫描完后取非图片链接继续扫描
        getLazyUrl(pageLinks, lazyPageLinks);
        if (pageLinks.isEmpty()) {
            if (null == prams || prams.length < 2) {
                Utils.error("请输入抓取地址");
                System.exit(1);
            } else {
                pageLinks.add(prams[1]);
                sites.add(Utils.getSite(prams[1]));
                Utils.writeStringToFile(siteData, "", false);
                Utils.writeCollectionToFile(siteData, sites);
            }
        }

        if (null != prams && prams.length >= 3) {
            Integer _imgMinSize = null;
            try {
                _imgMinSize = Integer.valueOf(prams[2]);
            } catch (Exception e) {
                Utils.error("抓取最小图片大小输入有误，必须大于等于0");
            }
            if (_imgMinSize == null || _imgMinSize < 0) {
                Utils.error("抓取最小图片大小输入有误，必须大于等于0");
            } else {
                imgMinSize = _imgMinSize;
                Utils.error("抓取最小图片大小为" + imgMinSize + "KB");
            }
        }

        if (autoSaveMemoryData) { //首次启动把启动时间作为最后一次自动保存时间
            lastAutoSaveMemoryDataTime = System.currentTimeMillis();
        }

        if (!readTimeOutImgs.isEmpty()) {
            Utils.info("重新下载上次超时的图片");
            List<PictInfo> _pictInfos = readTimeOutImgs.stream().map(p -> {
                return new PictInfo(p.getSite(), p.getTitle(), p.getUrl(), p.getHtmlUrl());
            }).collect(Collectors.toList());
            readTimeOutImgs.clear();
            DownLoad.downloadPict(_pictInfos);
        }

    }

    private static void getLazyUrl(List<String> pageLinks, List<String> lazyPageLinks) {
        //图片链接扫描完后取非图片链接继续扫描
        if (pageLinks.isEmpty() && !lazyPageLinks.isEmpty()) {
            int index = 0;
            String lazyUrl = lazyPageLinks.get(index);
            if (Utils.isSite(lazyUrl)) {
                if (lazyPageLinks.size() > 1) {
                    index = 1;
                    lazyUrl = lazyPageLinks.get(index);
                }
            }
            pageLinks.add(lazyUrl);
            lazyPageLinks.remove(index);
        }
    }

    private static void checkAndExecutCommand(List<String> pageLinks, List<String> lazyPageLinks) {

        readCommandToMemory("stop");

        if (stop || pageLinks.isEmpty()) {
            if (pageLinks.isEmpty()) {
                Utils.info("无法找到新的url，抓取图片结束");
            }
            writeMemoryDataToFile(pageLinks, lazyPageLinks);
            writeDefaultCommand();
            System.exit(0);
        }

    }

    private static void checkAutoSaveMemoryData(List<String> pageLinks, List<String> lazyPageLinks) {

        if (autoSaveMemoryData) {
            if (null == lastAutoSaveMemoryDataTime) {
                writeMemoryDataToFile(pageLinks, lazyPageLinks);
                writeDefaultCommand();
                lastAutoSaveMemoryDataTime = System.currentTimeMillis();
            } else if (System.currentTimeMillis() > (lastAutoSaveMemoryDataTime + (autoSaveMemoryDataInterval*60*1000))) {
                writeMemoryDataToFile(pageLinks, lazyPageLinks);
                writeDefaultCommand();
                lastAutoSaveMemoryDataTime = System.currentTimeMillis();
            }
        }

    }

    private static void writeDefaultCommand() {

        readCommandToMemory();

        Utils.writeStringToFile(commandFile, "", false);
        Utils.writeStringToFile(commandFile, "stop=false");
        Utils.writeStringToFile(commandFile, "imgMinSize=" + imgMinSize);
        Utils.writeStringToFile(commandFile, "nextPageNames=" + StringUtils.join(nextPageNames, ","));
        Utils.writeStringToFile(commandFile, "pageTitlefilters=" + StringUtils.join(pageTitlefilters, ","));
        Utils.writeStringToFile(commandFile, "imgNamefilters=" + StringUtils.join(imgNamefilters, ","));
        Utils.writeStringToFile(commandFile, "imgSrcRepletTags=" + StringUtils.join(imgSrcRepletTags, ","));
        Utils.writeStringToFile(commandFile, "allowDifferentCharacters=" + allowDifferentCharacters);
        Utils.writeStringToFile(commandFile, "browserTimeout=" + browserTimeout);
        Utils.writeStringToFile(commandFile, "jsTimeout=" + jsTimeout);
        Utils.writeStringToFile(commandFile, "jsEnabled=" + jsEnabled);
        Utils.writeStringToFile(commandFile, "waitForBackgroundJavaScript=" + waitForBackgroundJavaScript);
        Utils.writeStringToFile(commandFile, "refererUrl=" + refererUrl);
        Utils.writeStringToFile(commandFile, "transboundarySites=" + StringUtils.join(transboundarySites, ","));
        Utils.writeStringToFile(commandFile, "fixedUrlPrefix=" + fixedUrlPrefix);
        Utils.writeStringToFile(commandFile, "thread=" + thread);
        Utils.writeStringToFile(commandFile, "threadSize=" + threadSize);
        Utils.writeStringToFile(commandFile, "threadSleep=" + threadSleep);
        Utils.writeStringToFile(commandFile, "autoSaveMemoryData=" + autoSaveMemoryData);
        Utils.writeStringToFile(commandFile, "autoSaveMemoryDataInterval=" + autoSaveMemoryDataInterval);

    }

    private static void readCommandToMemory() {
        readCommandToMemory(Collections.EMPTY_LIST);
    }

    private static void readCommandToMemory(String key) {
        readCommandToMemory(Arrays.asList(new String[] {key}));
    }

    private static void readCommandToMemory(List<String> keys) {

        Set<String> command = new HashSet<String>(); //命令列表
        Utils.readFileDataToCollection(commandFile, command);
        for (String c : command) {
            String[] _c = c.split("=");
            if (_c.length != 2) {
                continue;
            }
            if (null != keys && !keys.isEmpty()) {
                boolean exists = false;
                for (String key : keys) {
                    if (_c[0].equals(key)) {
                        exists = true;
                        break;
                    }
                }
                if (!exists) {
                    continue;
                }
            }
            try {
                if (_c[0].equals("stop")) {
                    stop = Boolean.valueOf(_c[1]);
                } else if (_c[0].equals("imgMinSize")) {
                    imgMinSize = Long.valueOf(_c[1]);
                } else if (_c[0].equals("nextPageNames")) {
                    nextPageNames = Arrays.stream(_c[1].split(",")).collect(Collectors.toList());
                } else if (_c[0].equals("pageTitlefilters")) {
                    pageTitlefilters = Arrays.stream(_c[1].split(",")).collect(Collectors.toList());
                } else if (_c[0].equals("imgNamefilters")) {
                    imgNamefilters = Arrays.stream(_c[1].split(",")).collect(Collectors.toList());
                } else if (_c[0].equals("imgSrcRepletTags")) {
                        imgSrcRepletTags = Arrays.stream(_c[1].split(",")).collect(Collectors.toList());
                } else if (_c[0].equals("allowDifferentCharacters")) {
                    allowDifferentCharacters = String.valueOf(_c[1]);
                } else if (_c[0].equals("browserTimeout")) {
                    browserTimeout = Integer.valueOf(_c[1]);
                } else if (_c[0].equals("jsTimeout")) {
                    jsTimeout = Integer.valueOf(_c[1]);
                } else if (_c[0].equals("jsEnabled")) {
                    jsEnabled = Boolean.valueOf(_c[1]);
                } else if (_c[0].equals("waitForBackgroundJavaScript")) {
                    waitForBackgroundJavaScript = Integer.valueOf(_c[1]);
                }  else if (_c[0].equals("refererUrl")) {
                    refererUrl = _c[1];
                }  else if (_c[0].equals("transboundarySites")) {
                    transboundarySites = Arrays.stream(_c[1].split(",")).collect(Collectors.toSet());
                } else if (_c[0].equals("fixedUrlPrefix")) {
                    fixedUrlPrefix = _c[1];
                } else if (_c[0].equals("thread")) {
                    thread = Boolean.valueOf(_c[1]);
                } else if (_c[0].equals("threadSize")) {
                    threadSize = Integer.valueOf(_c[1]);
                } else if (_c[0].equals("threadSleep")) {
                    threadSleep = Integer.valueOf(_c[1]);
                } else if (_c[0].equals("autoSaveMemoryData")) {
                    autoSaveMemoryData = Boolean.valueOf(_c[1]);
                } else if (_c[0].equals("autoSaveMemoryDataInterval")) {
                    autoSaveMemoryDataInterval = Integer.valueOf(_c[1]);
                }
            } catch (Exception e) {
                e.printStackTrace();
                Utils.error("参数错误" + e.getMessage());
            }
        }

    }

    private static void writeMemoryDataToFile(List<String> pageLinks, List<String> lazyPageLinks) {
        Utils.info("正在保存重要的分析数据，请不要强制退出");
        //先用一条空数据把记录覆盖，再用新数据写入到记录文件中
        Utils.writeStringToFile(siteData, "", false);
        Utils.writeCollectionToFile(siteData, sites);
        Utils.writeStringToFile(allUrlData, "", false);
        Utils.writeCollectionToFile(allUrlData, pageSet);
        Utils.writeStringToFile(currentUrlData, "", false);
        Utils.writeCollectionToFile(currentUrlData, pageLinks);
        Utils.writeStringToFile(lazyUrlData, "", false);
        Utils.writeCollectionToFile(lazyUrlData, lazyPageLinks);
        Utils.writeStringToFile(downLoadedImgData, "", false);
        Utils.writeCollectionToFile(downLoadedImgData, imgDownloaded);
        Utils.writeStringToFile(downloadedImgDirNameData, "", false);
        Utils.writeCollectionToFile(downloadedImgDirNameData, imgDownloadedDirName);
        Utils.writeStringToFile(readTimeOutImgData, "", false);
        Utils.writePictInfoCollectionToFile(readTimeOutImgData, readTimeOutImgs);
    }

}

